// ################################################ //
// # TOOLBOX uW                                   # //
// #==============================================# //
// # Fonctions gnrales pour la gestion des S2P  # //
// # et de traitements de matrices [S]            # //
// ################################################ //


// ================================================ //
// T.Reveyrand     2007                             //
// v. 0.1                                           //
// ================================================ //

// DEF :
// =====

// (    )   [          ]  (    )
// ( a1 )   [ T11  T12 ]  ( b2 )
// (    ) = [          ]* (    )
// ( b1 )   [ T21  T22 ]  ( a2 )
// (    )   [          ]  (    )


// [Total] = TA * TB * TC
//        in             out

// ###########################################
// # Conversion d'une matrice 2 ports : S -> T
// ###########################################


function T=uW_S2T(S)
	freq=S.frequency;
	S11=S.S11;
	S12=S.S12;
	S21=S.S21;
	S22=S.S22;
	
	T22=(S12.*S21-S11.*S22)./S21;
	T21=S11./S21;
	T12=-S22./S21;
	T11=S21.^(-1);
	
	T=tlist(['T parameters';'frequency';'T11';'T12';'T21';'T22'],freq,T11,T12,T21,T22);
endfunction
